#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#  
# Copyright (c) 1995 International Computer Science Institute
# All Rights Reserved.
#
# Created by Wieland Holfelder (whd@icsi.berkeley.edu)
# Tenet Group
# International Computer Science Institute
#
# Permission to use, copy, modify, and distribute this software and its 
# documentation for educational, research and non-profit purposes, 
# without fee, and without a written agreement is hereby granted, 
# provided that the above copyright notice, this paragraph and the 
# following five paragraphs appear in all copies.  
#
# Permission to incorporate this software into commercial products may 
# be obtained from the International Computer Science Institute,
# 1947 Center Street, Suite 600, Berkeley, CA 94704. 
#
# IN NO EVENT SHALL THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE BE 
# LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR 
# CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE 
# USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS BEEN ADVISED OF THE POSSIBILITY OF 
# SUCH DAMAGE.
#
# THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE SPECIFICALLY DISCLAIMS 
# ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE 
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, 
# SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
#
# The International Computer Science Institute will appreciate 
# receiving any enhancements and modifications of this software 
# made by others, and reserves the right to include them in future 
# releases. The Institute also recommends that this software not 
# be redistributed by third parties, but be obtained by all directly 
# from the ICSI server, so that all users of the software may 
# receive bug notifications and other relevant announcements.
#
# The German Academic Exchange Service has supported the development 
# of this software. Their support is gratefully acknowledged.
#
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#
# $Id: edit_media.tcl,v 1.3 1996/08/12 11:35:48 whd Exp $ (ICSI)
# 
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

# procedure edit_media
proc edit_media { {mnb "0"} {new "0"} } {
    global VERSION DEMO_VERSION tmp_session media protocols media_nb tmp_media_saved

    # build widget .edit_media
    toplevel .edit_media -relief {raised}

    # Window manager configurations
    wm positionfrom .edit_media "program"
    wm sizefrom .edit_media "program"
    if { ($tmp_session(read_only) != "") } {
	wm title .edit_media "$VERSION (View Media)"
    } elseif { $new == "0"} {
	wm title .edit_media "$VERSION (Edit Media)"
    } else {
	wm title .edit_media "$VERSION (Add Media)"
    }
    
    clear_media
    set media_nb $mnb

    if {$new == 0} {
	foreach x [array names media] {
	    set media($x) $tmp_session(media_list,$media_nb,$x)
	}
    }
    if { $media(media_ttl) > $tmp_session(max_ttl) } {
	set media(media_ttl) $tmp_session(max_ttl)
    }

    set media(media_scope) [ttl2scope $media(media_ttl)]

    trace_media
    
    # build widget .edit_media.top
    frame .edit_media.top \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.top.title
    label .edit_media.top.title \
	    -height {2} \
	    -font {-*-helvetica-bold-r-normal--*-140-*}

    if { $tmp_session(read_only) != "" } {
	.edit_media.top.title configure -text {View Media}
    } elseif { $new == "0" } {
	.edit_media.top.title configure -text {Edit Media}
    } else {
	.edit_media.top.title configure -text {Add Media}
    }

    
    # pack widget .edit_media.top
    pack append .edit_media.top \
	    .edit_media.top.title {top frame center}
    
    # build widget .edit_media.middle
    frame .edit_media.middle \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.middle.name
    frame .edit_media.middle.name \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.middle.name.label
    label .edit_media.middle.name.label \
	    -padx {2} \
	    -relief {groove} \
	    -text {Media Name:} \
	    -width {15}
    
    # build widget .edit_media.middle.name.entry
    entry .edit_media.middle.name.entry \
	    -relief {sunken} \
	    -textvariable {media(media_name)}

    bind .edit_media.middle.name.entry <Return> {
	focus .edit_media.middle.desc.entry
    }

    # pack widget .edit_media.middle.name
    pack append .edit_media.middle.name \
	    .edit_media.middle.name.label {left frame center} \
	    .edit_media.middle.name.entry {top frame center expand fill}

    # build widget .edit_media.middle.desc
    frame .edit_media.middle.desc \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.middle.desc.label
    label .edit_media.middle.desc.label \
	    -padx {2} \
	    -relief {groove} \
	    -text {Media Desc:} \
	    -width {15}
    
    # build widget .edit_media.middle.desc.entry
    entry .edit_media.middle.desc.entry \
	    -relief {sunken} \
	    -textvariable {media(media_desc)}

    bind .edit_media.middle.desc.entry <Return> {
	focus .edit_media.middle.ipaddress.entry
    }
  
    # pack widget .edit_media.middle.desc
    pack append .edit_media.middle.desc \
	    .edit_media.middle.desc.label {left frame center} \
	    .edit_media.middle.desc.entry {top frame center expand fill}
    
    # build widget .edit_media.middle.ipaddress
    frame .edit_media.middle.ipaddress \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.middle.ipaddress.label
    label .edit_media.middle.ipaddress.label \
	    -padx {2} \
	    -relief {groove} \
	    -text {IP Address:} \
	    -width {15}
    
    # build widget .edit_media.middle.ipaddress.entry
    entry .edit_media.middle.ipaddress.entry \
	    -relief {sunken} \
    	    -textvariable {media(media_ip)}

    bind .edit_media.middle.ipaddress.entry <Return> {
	focus .edit_media.middle.portnumber.entry
    }
      
    # pack widget .edit_media.middle.ipaddress
    pack append .edit_media.middle.ipaddress \
	    .edit_media.middle.ipaddress.label {left frame center} \
	    .edit_media.middle.ipaddress.entry {top frame center expand fill}
    
    # build widget .edit_media.middle.portnumber
    frame .edit_media.middle.portnumber \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.middle.portnumber.label
    label .edit_media.middle.portnumber.label \
	    -padx {2} \
	    -relief {groove} \
	    -text {Portnumber:} \
	    -width {15}
    
    # build widget .edit_media.middle.portnumber.entry
    entry .edit_media.middle.portnumber.entry \
	    -relief {sunken} \
	    -textvariable {media(media_port)}

    bind .edit_media.middle.portnumber.entry <Return> {
	focus .edit_media.middle.cid.entry
    }

    # pack widget .edit_media.middle.portnumber
    pack append .edit_media.middle.portnumber \
	    .edit_media.middle.portnumber.label {left frame center} \
	    .edit_media.middle.portnumber.entry {top frame center expand fill}
    
    # build widget .edit_media.middle.cid
    frame .edit_media.middle.cid \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.middle.cid.label
    label .edit_media.middle.cid.label \
	    -padx {2} \
	    -relief {groove} \
	    -text {Confid:} \
	    -width {15}
    
    # build widget .edit_media.middle.cid.entry
    entry .edit_media.middle.cid.entry \
	    -relief {sunken} \
    	    -textvariable {media(media_cid)}

    bind .edit_media.middle.cid.entry <Return> {
	focus .edit_media.middle.command.entry
    }
   
    # pack widget .edit_media.middle.cid
    pack append .edit_media.middle.cid \
	    .edit_media.middle.cid.label {left frame center} \
	    .edit_media.middle.cid.entry {top frame center expand fill}
    
    # build widget .edit_media.middle.type
    frame .edit_media.middle.type \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .edit_media.middle.type.label
    label .edit_media.middle.type.label \
	    -relief {groove} \
	    -padx {2} \
	    -text {Protocol:} \
	    -width {15}

    # build widget .edit_media.middle.type.label
    label .edit_media.middle.type.label2 \
	    -relief {sunken} \
	    -text "[string toupper $protocols($media(media_type))]"

    if { $tmp_session(read_only) == "" } {
	# build widget .edit_media.middle.type.menu
	menubutton .edit_media.middle.type.menu \
		-menu {.edit_media.middle.type.menu.m} \
		-relief {groove} \
		-padx {2} \
		-text { << }
	
	# build widget .edit_media.middle.type.menu.m
	menu .edit_media.middle.type.menu.m -tearoff 0
	
#	for {set i 0} {$i < [array size protocols]} {incr i} {
# don't offer anything else than rtp since vat is now RTPv0 and nothing else than RTP is supported yet
    set i 1
	    
	    .edit_media.middle.type.menu.m add command \
		    -label "[string toupper $protocols($i)]" \
		    -command "
	    .edit_media.middle.type.label2 configure -text [string toupper $protocols($i)]
	    set media(media_type) $i
	    "
#	}

	# pack widget .edit_media.middle.type
	pack append .edit_media.middle.type \
		.edit_media.middle.type.label {left frame center fill} \
		.edit_media.middle.type.label2 {left frame center expand fill} \
		.edit_media.middle.type.menu {right frame center fill}
    } else {
	# pack widget .edit_media.middle.type
	pack append .edit_media.middle.type \
		.edit_media.middle.type.label {left frame center fill} \
		.edit_media.middle.type.label2 {left frame center expand fill}
    }
    
    # build widget .edit_media.middle.scope
    frame .edit_media.middle.scope \
	    -borderwidth {4} \
	    -relief {raised}
    
    # build widget .edit_media.middle.scope.label
    label .edit_media.middle.scope.label \
	    -relief {groove} \
	    -width {15}\
	    -text {Scope:}
    
    # build widget .edit_media.middle.scope.host
    radiobutton .edit_media.middle.scope.host \
	    -command {
	.edit_media.middle.scope.entry configure -state disabled
	set media(media_ttl) [scope2ttl $media(media_scope)]
    }\
	    -relief {flat} \
	    -text {host} \
	    -value {host} \
	    -variable {media(media_scope)}
    
    # build widget .edit_media.middle.scope.site
    radiobutton .edit_media.middle.scope.site \
	    -command {
	.edit_media.middle.scope.entry configure -state disabled
	set media(media_ttl) [scope2ttl $media(media_scope)]
    }\
	    -relief {flat} \
	    -text {site} \
	    -value {site} \
	    -variable {media(media_scope)}
    
    # build widget .edit_media.middle.scope.region
    radiobutton .edit_media.middle.scope.region \
	    -command {
	.edit_media.middle.scope.entry configure -state disabled
	set media(media_ttl) [scope2ttl $media(media_scope)]
    }\
	    -relief {flat} \
	    -text {region} \
	    -value {region} \
	    -variable {media(media_scope)}
    
    # build widget .edit_media.middle.scope.continent
    radiobutton .edit_media.middle.scope.continent \
	    -command {
	.edit_media.middle.scope.entry configure -state disabled
	set media(media_ttl) [scope2ttl $media(media_scope)]
    } \
	    -relief {flat} \
	    -text {cont.} \
	    -value {continent} \
	    -variable {media(media_scope)}

    # build widget .edit_media.middle.scope.world
    radiobutton .edit_media.middle.scope.world \
	    -command {
	.edit_media.middle.scope.entry configure -state disabled
	set media(media_ttl) [scope2ttl $media(media_scope)]
    } \
	    -relief {flat} \
	    -text {world} \
	    -value {world} \
	    -variable {media(media_scope)}
    
    # build widget .edit_media.middle.scope.other
    radiobutton .edit_media.middle.scope.other \
	    -command {.edit_media.middle.scope.entry configure -state normal} \
	    -relief {flat} \
	    -text {} \
	    -value {other} \
	    -variable {media(media_scope)}
    
    # build widget .edit_media.middle.scope.entry
    entry .edit_media.middle.scope.entry \
	    -relief {sunken} \
	    -textvariable {media(media_ttl)} \
	    -width {5}
    
    # pack widget .edit_media.middle.scope
    pack append .edit_media.middle.scope \
	    .edit_media.middle.scope.label {left frame center} \
	    .edit_media.middle.scope.host {left frame center} \
	    .edit_media.middle.scope.site {left frame center} \
	    .edit_media.middle.scope.region {left frame center} \
	    .edit_media.middle.scope.continent {left frame center} \
	    .edit_media.middle.scope.world {left frame center} \
	    .edit_media.middle.scope.other {left frame center} \
	    .edit_media.middle.scope.entry {left frame center}


    # build widget .edit_media.middle.command
    frame .edit_media.middle.command \
	    -borderwidth {2} \
	    -relief {raised}
    
    
    # build widget .edit_media.middle.command.label
    label .edit_media.middle.command.label \
	    -padx {2} \
	    -relief {groove} \
	    -text {Media Command:} \
	    -width {15}

    # build widget .edit_media.middle.command.entry
    entry .edit_media.middle.command.entry \
	    -textvariable {media(media_cmd)} \
	    -relief {sunken}

    if { $tmp_session(read_only) == "" } {
	# build widget .edit_media.middle.command.label_button
	button .edit_media.middle.command.button \
		-padx {2} \
		-relief {groove} \
		-text { << } \
		-command {
	    set media_cmd [FSBox "Select playback command for media \"$media(media_name)\"" "$media(media_cmd)" "" "" "*" "$VERSION (set media cmd)"]
	    if {$media_cmd !=""} {
		set media(media_cmd) $media_cmd
	    }
	}

	# pack widget .edit_media.middle.command
	pack append .edit_media.middle.command \
		.edit_media.middle.command.label {left frame center fill} \
		.edit_media.middle.command.entry {left frame center expand fill} \
		.edit_media.middle.command.button {right frame center fill}
    } else {
	# pack widget .edit_media.middle.command
	pack append .edit_media.middle.command \
		.edit_media.middle.command.label {left frame center fill} \
		.edit_media.middle.command.entry {left frame center expand fill}
    }
    
    
    # pack widget .edit_media.middle
    pack append .edit_media.middle \
	    .edit_media.middle.name {top frame center expand fill} \
	    .edit_media.middle.desc {top frame center expand fill} \
	    .edit_media.middle.ipaddress {top frame center expand fill} \
	    .edit_media.middle.portnumber {top frame center expand fill} \
	    .edit_media.middle.cid {top frame center expand fill} \
	    .edit_media.middle.type {top frame center expand fill} \
	    .edit_media.middle.command {top frame center expand fill} \
	    .edit_media.middle.scope {top frame center expand fill}
    
    # build widget .edit_media.bottom
    frame .edit_media.bottom \
	    -borderwidth {2} \
	    -relief {raised}


    if { $tmp_session(read_only) == "" } {
	# build widget .edit_media.bottom.ok
	button .edit_media.bottom.ok \
		-text {Ok} \
		-width {20} \
		-command {
	    global tmp_session media tmp_media_saved media_nb
	    
	    untrace_media
	    set media(media_ttl) [scope2ttl $media(media_scope) $media(media_ttl)]
	    
	    if { $media(media_ttl) > $tmp_session(max_ttl) } {
		AlertBox "\n $VERSION error: \n\n Max. ttl for this session is \
			$tmp_session(max_ttl). \n" "" "" "$VERSION (Edit Media)" Ok
		
		set media(media_ttl) $tmp_session(max_ttl)
		trace_media
		return
	    }
	    
	    if { [scope_warning $media(media_ttl)] == 1 } {
		trace_media
		return
	    }

	    if {$media(media_name) == ""} {
		AlertBox "\n $VERSION error: \n\n Please specify a media name. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }
	    if {$media(media_ip) == ""} {
		AlertBox "\n $VERSION error: \n\n Please specify an ip address. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }

	    if { [regexp {^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$} $media(media_ip)] == "0"} {
		AlertBox "\n $VERSION error: \n\n $media(media_ip) is not a valid IP address. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }

	    if {$media(media_port) == ""} {
		AlertBox "\n $VERSION error: \n\n Please specify a port number. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }
	    if { [regexp {^[0-9]+$} $media(media_port)] == "0" } {
		AlertBox "\n $VERSION error: \n\n $media(media_port) is not a valid port number. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }
	    if { ($media(media_port) < 1024) || ($media(media_port) > 65535) } {
		AlertBox "\n $VERSION error: \n\n $media(media_port) is not a valid port number. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }

	    if {$media(media_cid) == ""} {
		if { ($media(media_type) == "1") && \
   		     ([string first "nv" [file tail $media(media_cmd)]] >= 0) } {
		    /* NV's default conference id is not 0 but 32 ... */
		    set media(media_cid) "32"
		} else {
		    set media(media_cid) "0"
		}
	    }

	    if { [regexp {^[0-9]+$} $media(media_cid)] == "0"} {
		AlertBox "\n $VERSION error: \n\n $media(media_cid) is not a valid conference id. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }

	    if {$media(media_type) == "0"} {
		AlertBox "\n $VERSION error: \n\n Please select a protocol. \n"\
			"" "" "$VERSION (Edit Media)" Ok
		
		trace_media
		return
	    }

	    if {$media_nb > $tmp_session(nb_of_media)} {
		set found 0
		for {set i 1} {$i <= $tmp_session(nb_of_media)} {incr i} {
		    if {[string trim $tmp_session(media_list,$i,media_name)] == \
			    [string trim $media(media_name)] } { set found 1}
		    
		}
		if { $found == 1} {
		    AlertBox "\n $VERSION error: \n\n This media name already exists in this \
			    session. \n Please chosse another one. \n"\
			    "" "" "$VERSION (Edit Media)" Ok
		    trace_media
		    return
		}
		set tmp_session(nb_of_media) $media_nb
	    }
	    
	    foreach x [array names media] {
		set tmp_session(media_list,$media_nb,$x) $media($x)
	    }

	    set tmp_session(saved) $tmp_media_saved
	    if { $tmp_media_saved == 0 } { set session(saved) $tmp_media_saved }
	    destroy .edit_media
	    if { [winfo exists .edit_session] == 0} {
		fill_session
		update_session
		update_main_win
	    } else {
		update_session_win
		catch {vcr_grab .edit_session}
	    }
	}
    }
    
    # build widget .edit_media.bottom.cancel
    button .edit_media.bottom.cancel \
	    -text {Cancel} \
	    -width {20} \
	    -command {
	untrace_media
	destroy .edit_media
	vcr_grab .edit_session
    }
    
    if { $tmp_session(read_only) == "" } {
	# pack widget .edit_media.bottom
	pack append .edit_media.bottom \
		.edit_media.bottom.ok {left frame center padx 40 pady 20} \
		.edit_media.bottom.cancel {right frame center padx 40 pady 20}
    } else {
	pack append .edit_media.bottom \
		.edit_media.bottom.cancel {expand frame center padx 60 pady 20}
    }
    
    # pack widget .edit_media
    pack append .edit_media \
	    .edit_media.top {top frame center expand fill} \
	    .edit_media.middle {top frame center expand fill} \
	    .edit_media.bottom {top frame center expand fill}


    if { $tmp_session(read_only) == "" } {
	if {$tmp_session(max_ttl) < [scope2ttl "host"]} {
	    .edit_media.middle.scope.host configure -state disabled
	} 
	if {$tmp_session(max_ttl) < [scope2ttl "site"]} {
	    .edit_media.middle.scope.site configure -state disabled
	} 
	if {$tmp_session(max_ttl) < [scope2ttl "region"]} {
	    .edit_media.middle.scope.region configure -state disabled
	} 
	if {$tmp_session(max_ttl) < [scope2ttl "continent"]} {
	    .edit_media.middle.scope.continent configure -state disabled
	} 
	if {$tmp_session(max_ttl) < [scope2ttl "world"]} {
	    .edit_media.middle.scope.world configure -state disabled
	}
    } else {
	.edit_media.middle.name.entry configure -state disabled
	.edit_media.middle.desc.entry configure -state disabled
	.edit_media.middle.ipaddress.entry configure -state disabled
	.edit_media.middle.portnumber.entry configure -state disabled
	.edit_media.middle.cid.entry configure -state disabled
	.edit_media.middle.command.entry configure -state disabled

	.edit_media.middle.scope.host configure -state disabled
	.edit_media.middle.scope.site configure -state disabled
	.edit_media.middle.scope.region configure -state disabled
	.edit_media.middle.scope.continent configure -state disabled
	.edit_media.middle.scope.world configure -state disabled
	.edit_media.middle.scope.other configure -state disabled
	.edit_media.middle.scope.entry configure -state disabled
	
    }
    focus .edit_media.middle.name.entry
    vcr_grab .edit_media
}

proc media_need_save { name element op } { 
    global tmp_media_saved
    set tmp_media_saved "0"
    return
}

proc trace_media {} {
    global media tmp_media_saved
    set tmp_media_saved "1"
    foreach x [array names media] {
	trace variable media($x) w media_need_save
    }
}

proc untrace_media {} {
    global media
    foreach x [array names media] {
	trace vdelete media($x) w media_need_save
    }
}

# eof
#

