#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#  
# Copyright (c) 1995 International Computer Science Institute
# All Rights Reserved.
#
# Created by Wieland Holfelder (whd@icsi.berkeley.edu)
# Tenet Group
# International Computer Science Institute
#
# Permission to use, copy, modify, and distribute this software and its 
# documentation for educational, research and non-profit purposes, 
# without fee, and without a written agreement is hereby granted, 
# provided that the above copyright notice, this paragraph and the 
# following five paragraphs appear in all copies.  
#
# Permission to incorporate this software into commercial products may 
# be obtained from the International Computer Science Institute,
# 1947 Center Street, Suite 600, Berkeley, CA 94704. 
#
# IN NO EVENT SHALL THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE BE 
# LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR 
# CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE 
# USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS BEEN ADVISED OF THE POSSIBILITY OF 
# SUCH DAMAGE.
#
# THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE SPECIFICALLY DISCLAIMS 
# ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE 
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, 
# SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
#
# The International Computer Science Institute will appreciate 
# receiving any enhancements and modifications of this software 
# made by others, and reserves the right to include them in future 
# releases. The Institute also recommends that this software not 
# be redistributed by third parties, but be obtained by all directly 
# from the ICSI server, so that all users of the software may 
# receive bug notifications and other relevant announcements.
#
# The German Academic Exchange Service has supported the development 
# of this software. Their support is gratefully acknowledged.
#
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#
# $Id: how2start.tcl,v 1.1 1996/07/26 12:12:57 whd Exp $ (ICSI)
# 
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc how2start_vat { {rhost ""} {cmd "vat"} {ip "224.2.0.1"} {port "3456"} {ttl "15"} {cid "0"} {session_name ""} } {
    global VERSION
    set display ""
    if { $rhost != ""} { 
	set display "-display ${rhost}:0"
	set rhost "rsh $rhost"
    } 
    if { "$cmd" == "" } { set cmd "vat" } 
    if { [string first "vat" "[file tail $cmd]"] >= 0 } {
	return "$rhost $cmd $display -t $ttl ${ip}/${port}/${cid}"
    } else {
	AlertBox "\n $VERSION error: \n\n Don't know how to start $cmd \n\n" \
		"" "" "$VERSION (Start Sessiontools)" Ok
	puts "Don't know how to start $cmd?"
	return ""
    }
}

proc how2start_rtp { {rhost ""} {cmd ""} {ip "224.2.1.1"} {port "4444"} {ttl "15"} {cid "32"} {session_name ""} } {
    global VERSION
    set display ""
    if { $rhost != ""} {
	set display "${rhost}:0"
	set rhost "rsh $rhost" 
    }
    if { "$cmd" == "" } { set cmd "vic" }
    if { [string first "vat" "[file tail $cmd]"] >= 0 } {
	# it's probably vat ... "
	if { $display != ""} { set display "-d $display"}
	return "$rhost $cmd $display -t $ttl ${ip}/${port}"
    } elseif { [string first "vic" "[file tail $cmd]"] >= 0 } {
	# it's probably vic ... "
	if { $display != ""} { set display "-d $display"}
	return "$rhost $cmd $display -t $ttl ${ip}/${port}"
    } elseif { [string first "nv" "[file tail $cmd]"] >= 0 } {
	# it's probably nv ... "
	if { $display != ""} { set display "-display $display"}
	return "$rhost $cmd $display -ttl $ttl ${ip} ${port} ${cid}"
    } else {
	AlertBox "\n $VERSION error: \n\n Don't know how to start $cmd \n\n" \
		"" "" "$VERSION (Start Sessiontools)" Ok
	puts "Don't know how to start $cmd?"
	return ""
    }
}

