#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#  
# Copyright (c) 1995 International Computer Science Institute
# All Rights Reserved.
#
# Created by Wieland Holfelder (whd@icsi.berkeley.edu)
# Tenet Group
# International Computer Science Institute
#
# Permission to use, copy, modify, and distribute this software and its 
# documentation for educational, research and non-profit purposes, 
# without fee, and without a written agreement is hereby granted, 
# provided that the above copyright notice, this paragraph and the 
# following five paragraphs appear in all copies.  
#
# Permission to incorporate this software into commercial products may 
# be obtained from the International Computer Science Institute,
# 1947 Center Street, Suite 600, Berkeley, CA 94704. 
#
# IN NO EVENT SHALL THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE BE 
# LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR 
# CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE 
# USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS BEEN ADVISED OF THE POSSIBILITY OF 
# SUCH DAMAGE.
#
# THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE SPECIFICALLY DISCLAIMS 
# ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE 
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, 
# SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
#
# The International Computer Science Institute will appreciate 
# receiving any enhancements and modifications of this software 
# made by others, and reserves the right to include them in future 
# releases. The Institute also recommends that this software not 
# be redistributed by third parties, but be obtained by all directly 
# from the ICSI server, so that all users of the software may 
# receive bug notifications and other relevant announcements.
#
# The German Academic Exchange Service has supported the development 
# of this software. Their support is gratefully acknowledged.
#
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#
# $Id: index_ctrl.tcl,v 1.1 1996/07/26 12:12:57 whd Exp $ (ICSI)
# 
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

# procedure to show window .index_ctrl
proc show_index_ctrl {args} {
    global VERSION session media bmp index_list new_index_list nb_of_indices 
    global idx_delete_mode idx_add_mode curr_time index_level

    # build widget .index_ctrl
    toplevel .index_ctrl 

    # bindings
    bind .index_ctrl <Enter> { focus %W }
    bind .index_ctrl <q> { toggle_index_ctrl }
    bind .index_ctrl <Control-c> { toggle_index_ctrl }
    bind .index_ctrl <Control-d> { toggle_index_ctrl }
    bind .index_ctrl <i> { toggle_index_ctrl }

    set session(index_ctrl) "1"

    # Window manager configurations
    global tk_version
    wm positionfrom .index_ctrl "program"
    wm sizefrom .index_ctrl "program"
    wm title .index_ctrl "$VERSION (Indexcontrol)"
    
    # build widget .index_ctrl.top
    frame .index_ctrl.top \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .index_ctrl.top.title
    frame .index_ctrl.top.title
    
    # build widget .index_ctrl.top.title.label
    label .index_ctrl.top.title.label \
	    -font {-*-helvetica-bold-r-normal--*-140-*} \
	    -height {2} \
	    -text "$VERSION (Indexcontrol)"
    
    # pack widget .index_ctrl.top.title
    pack append .index_ctrl.top.title \
	    .index_ctrl.top.title.label {top frame center}
    
    # pack widget .index_ctrl.top
    pack append .index_ctrl.top \
	    .index_ctrl.top.title {top frame center padx 20 pady 20 expand fillx}
    
    # build widget .index_ctrl.middle
    frame .index_ctrl.middle \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .index_ctrl.middle.media_desc
    frame .index_ctrl.middle.media_desc \
	    -borderwidth {2}
    
    # build widget .index_ctrl.middle.media_desc.mediabutton
    menubutton .index_ctrl.middle.media_desc.mediabutton \
	    -menu {.index_ctrl.middle.media_desc.mediabutton.m} \
	    -relief {groove} \
	    -text {Indexmedia:}
    
    # build widget .index_ctrl.middle.media_desc.media_display
    label .index_ctrl.middle.media_desc.media_display \
	    -relief {sunken} \
	    -borderwidth {1} \
	    -width {36} \
	    -anchor {w} \
	    -text {- none -}
    
    # build widget .index_ctrl.middle.media_desc.mediabutton.m
    menu .index_ctrl.middle.media_desc.mediabutton.m

    # pack widget .index_ctrl.middle.media_desc
    pack append .index_ctrl.middle.media_desc \
	    .index_ctrl.middle.media_desc.mediabutton {left frame center} \
	    .index_ctrl.middle.media_desc.media_display {left frame center expand}
    
    # build widget .index_ctrl.middle.index_list
    frame .index_ctrl.middle.index_list \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .index_ctrl.middle.index_list.scrollbar
    scrollbar .index_ctrl.middle.index_list.scrollbar \
	    -command {.index_ctrl.middle.index_list.listbox yview} \
	    -borderwidth {1} \
	    -width {10}
    
    # build widget .index_ctrl.middle.index_list.listbox
    listbox .index_ctrl.middle.index_list.listbox \
	    -yscrollcommand {.index_ctrl.middle.index_list.scrollbar set} \
	    -selectmode {extended} \
	    -relief {groove}

    
    bind_click_on_index 
    
    # pack widget .index_ctrl.middle.index_list
    pack append .index_ctrl.middle.index_list \
	    .index_ctrl.middle.index_list.listbox {left frame center expand fill} \
	    .index_ctrl.middle.index_list.scrollbar {right frame center filly}
    
    # build widget .index_ctrl.middle.index_cmds
    frame .index_ctrl.middle.index_cmds \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .index_ctrl.middle.index_cmds.delete
    button .index_ctrl.middle.index_cmds.delete \
	    -text {delete} \
	    -command {
	
	if { [can_write_index] == "0" } { return }
	set selection [.index_ctrl.middle.index_list.listbox curselection]
	if {$selection == ""} {
	    AlertBox "\n $VERSION error: \n\n No index selected. \n" "" ""\
		    "$VERSION (Index Control)" Ok
	} else {
	    delete_indices $selection
	}
    }

    button .index_ctrl.middle.index_cmds.delete_all \
	    -text {delete all} \
	    -command {
	delete_all_indices
    }
    
    # build widget .index_ctrl.middle.index_cmds.add
    button .index_ctrl.middle.index_cmds.add \
	    -text "add (1)" \
	    -command {
	if { [can_write_index] == "0" } { return }
	if { $idx_add_mode == "list_and_file" } {
	    set index_entries [vcr_ctrl index set $session(index_media) \
		    $index_values(USER$index_level)]
	} else {
	    set index_entries "\"[vcr_ctrl get_ts $session(index_media)] \
	    $index_values(USER$index_level) $curr_time USER_INDEX ($index_level)*\""
	}
	set new_index_list $index_list($session(index_media))
	add_index "$index_entries"
	update_index_listbox
	set ie [string range $index_entries 1 [expr [string length $index_entries] - 3]]
	set y1 [lsearch -exact $index_list($session(index_media)) $ie]
	if { $y1 < 9 } {
	    set y2 0
	} else {
	    set y2 [expr $y1 - 9]
	}
	.index_ctrl.middle.index_list.listbox yview $y2
	.index_ctrl.middle.index_list.listbox select set $y1 $y1
    }
    
    # build widget .index_ctrl.middle.index_cmds.get
    button .index_ctrl.middle.index_cmds.get \
	    -text {get} \
	    -command {
	if { [can_use_index] == "0" } { return }
	get_indices
    }
    
    # pack widget .index_ctrl.middle.index_cmds
    pack append .index_ctrl.middle.index_cmds \
	    .index_ctrl.middle.index_cmds.get {left frame center expand fillx} \
	    .index_ctrl.middle.index_cmds.add {left frame center expand fillx} \
	    .index_ctrl.middle.index_cmds.delete {left frame center expand fillx} \
	    .index_ctrl.middle.index_cmds.delete_all {left frame center expand fillx}
    
    # build widget .index_ctrl.middle.levels
    frame .index_ctrl.middle.levels \
	    -borderwidth {2}
    
    #-font {*helvetica-bold-r-normal-*-10*}
    # build widget .index_ctrl.middle.levels.level1
    radiobutton .index_ctrl.middle.levels.level1 \
	    -relief {flat} \
	    -text {level 1} \
	    -value {1} \
	    -variable {index_level} \
	    -command {
	.index_ctrl.middle.skip_cmds.prev_index configure \
		-bitmap $bmp(prev_index_1)
	.index_ctrl.middle.skip_cmds.next_index configure \
		-bitmap $bmp(next_index_1)
	.index_ctrl.middle.index_cmds.add configure \
		-text "add (1)"
    }

    
    # build widget .index_ctrl.middle.levels.level2
    radiobutton .index_ctrl.middle.levels.level2 \
	    -relief {flat} \
	    -text {level 2} \
	    -value {2} \
	    -variable {index_level} \
	    -command {
	.index_ctrl.middle.skip_cmds.prev_index configure \
		-bitmap $bmp(prev_index_2)
	.index_ctrl.middle.skip_cmds.next_index configure \
		-bitmap $bmp(next_index_2)
	.index_ctrl.middle.index_cmds.add configure \
		-text "add (2)"
    }
    
    # build widget .index_ctrl.middle.levels.level3
    radiobutton .index_ctrl.middle.levels.level3 \
	    -relief {flat} \
	    -text {level 3} \
	    -value {3} \
	    -variable {index_level} \
	    -command {
	.index_ctrl.middle.skip_cmds.prev_index configure \
		-bitmap $bmp(prev_index_3)
	.index_ctrl.middle.skip_cmds.next_index configure \
		-bitmap $bmp(next_index_3)
	.index_ctrl.middle.index_cmds.add configure \
		-text "add (3)"
    }

    
    # build widget .index_ctrl.middle.levels.level4
    radiobutton .index_ctrl.middle.levels.level4 \
	    -relief {flat} \
	    -text {level 4} \
	    -value {4} \
	    -variable {index_level} \
	    -command {
	.index_ctrl.middle.skip_cmds.prev_index configure \
		-bitmap $bmp(prev_index_4)
	.index_ctrl.middle.skip_cmds.next_index configure \
		-bitmap $bmp(next_index_4)
	.index_ctrl.middle.index_cmds.add configure \
		-text "add (4)"
    }

    
    # build widget .index_ctrl.middle.levels.level5
    radiobutton .index_ctrl.middle.levels.level5 \
	    -relief {flat} \
	    -text {level 5} \
	    -value {5} \
	    -variable {index_level} \
	    -command {
	.index_ctrl.middle.skip_cmds.prev_index configure \
		-bitmap $bmp(prev_index_5)
	.index_ctrl.middle.skip_cmds.next_index configure \
		-bitmap $bmp(next_index_5)
	.index_ctrl.middle.index_cmds.add configure \
		-text "add (5)"
    }
    
    # pack widget .index_ctrl.middle.levels
    pack append .index_ctrl.middle.levels \
	    .index_ctrl.middle.levels.level1 {left frame center expand fillx} \
	    .index_ctrl.middle.levels.level2 {left frame center expand fillx} \
	    .index_ctrl.middle.levels.level3 {left frame center expand fillx} \
	    .index_ctrl.middle.levels.level4 {left frame center expand fillx} \
	    .index_ctrl.middle.levels.level5 {left frame center expand fillx}
    
    # build widget .index_ctrl.middle.skip_cmds
    frame .index_ctrl.middle.skip_cmds \
	    -borderwidth {0} \
	    -relief {flat}
    
    # build widget .index_ctrl.middle.skip_cmds.prev_index
    button .index_ctrl.middle.skip_cmds.prev_index \
	    -bitmap "$bmp(prev_index_1)" \
	    -command {
	if { [can_use_index] == "0" } { return }
	vcr_ctrl goto prev_index $session(index_media) $index_values(USER$index_level)
    }
    
    # build widget .index_ctrl.middle.skip_cmds.prev_speaker
    button .index_ctrl.middle.skip_cmds.prev_speaker \
	    -bitmap "$bmp(prev_speaker)" \
	    -command {
	if { [can_use_index] == "0" } { return }
	vcr_ctrl goto prev_index $session(index_media) $index_values(NEW_SP) 
    }
    
    # build widget .index_ctrl.middle.skip_cmds.prev_ts
    button .index_ctrl.middle.skip_cmds.prev_ts \
	    -bitmap "$bmp(prev_ts)" \
	    -command {
	if { [can_use_index] == "0" } { return }
	vcr_ctrl goto prev_index $session(index_media) $index_values(NEW_TS)
    }

    # build widget .index_ctrl.middle.skip_cmds.next_ts
    button .index_ctrl.middle.skip_cmds.next_ts \
	    -bitmap "$bmp(next_ts)" \
	    -command {
	if { [can_use_index] == "0" } { return }
	vcr_ctrl goto next_index $session(index_media) $index_values(NEW_TS) 
    }
    
    # build widget .index_ctrl.middle.skip_cmds.next_speaker
    button .index_ctrl.middle.skip_cmds.next_speaker \
	    -bitmap "$bmp(next_speaker)" \
	    -command {
	if { [can_use_index] == "0" } { return }
	vcr_ctrl goto next_index $session(index_media) $index_values(NEW_SP)
    }

    # build widget .index_ctrl.middle.skip_cmds.next_index
    button .index_ctrl.middle.skip_cmds.next_index \
	    -bitmap "$bmp(next_index_1)" \
	    -command {
	if { [can_use_index] == "0" } { return }
	vcr_ctrl goto next_index $session(index_media) $index_values(USER$index_level)
    }
    
    # pack widget .index_ctrl.middle.
    pack append .index_ctrl.middle.skip_cmds \
	    .index_ctrl.middle.skip_cmds.prev_index {left frame center expand} \
	    .index_ctrl.middle.skip_cmds.prev_speaker {left frame center expand} \
	    .index_ctrl.middle.skip_cmds.prev_ts {left frame center expand} \
	    .index_ctrl.middle.skip_cmds.next_ts {left frame center expand} \
	    .index_ctrl.middle.skip_cmds.next_speaker {left frame center expand} \
	    .index_ctrl.middle.skip_cmds.next_index {left frame center expand}

    bind .index_ctrl.middle.skip_cmds.prev_index <Enter> {
	.index_ctrl.middle.skip_desc configure -text "goto previous index"
    }
    bind .index_ctrl.middle.skip_cmds.prev_ts <Enter> {
	.index_ctrl.middle.skip_desc configure -text "goto previous sync unit"
    }
    bind .index_ctrl.middle.skip_cmds.prev_speaker <Enter> {
	.index_ctrl.middle.skip_desc configure -text "goto previous speaker"
    }
    bind .index_ctrl.middle.skip_cmds.next_index <Enter> {
	.index_ctrl.middle.skip_desc configure -text "goto next index"
    }
    bind .index_ctrl.middle.skip_cmds.next_ts <Enter> {
	.index_ctrl.middle.skip_desc configure -text "goto next sync unit"
    }
    bind .index_ctrl.middle.skip_cmds.next_speaker <Enter> {
	.index_ctrl.middle.skip_desc configure -text "goto next speaker"
    }

    bind .index_ctrl.middle.skip_cmds.prev_index <Leave> {
	.index_ctrl.middle.skip_desc configure -text ""
    }
    bind .index_ctrl.middle.skip_cmds.prev_ts <Leave> {
	.index_ctrl.middle.skip_desc configure -text ""
    }
    bind .index_ctrl.middle.skip_cmds.prev_speaker <Leave> {
	.index_ctrl.middle.skip_desc configure -text ""
    }
    bind .index_ctrl.middle.skip_cmds.next_index <Leave> {
	.index_ctrl.middle.skip_desc configure -text ""
    }
    bind .index_ctrl.middle.skip_cmds.next_ts <Leave> {
	.index_ctrl.middle.skip_desc configure -text ""
    }
    bind .index_ctrl.middle.skip_cmds.next_speaker <Leave> {
	.index_ctrl.middle.skip_desc configure -text ""
    }

    label .index_ctrl.middle.skip_desc \
	    -font {-*-helvetica-bold-r-normal--*-180-40-40-*-*-*-*}


    # build widget .index_ctrl.middle.bottom
    frame .index_ctrl.middle.bottom \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .index_ctrl.middle.bottom.how2delete
    frame .index_ctrl.middle.bottom.how2delete \
	    -borderwidth {2}
    
    # build widget .index_ctrl.middle.bottom.how2delete.label9
    label .index_ctrl.middle.bottom.how2delete.label9 \
	    -borderwidth {0} \
	    -text {Delete:}
    
    # build widget .index_ctrl.middle.bottom.how2delete.radiobutton10
    radiobutton .index_ctrl.middle.bottom.how2delete.radiobutton10 \
	    -relief {flat} \
	    -text {from list and file} \
	    -value {list_and_file} \
	    -variable {idx_delete_mode}
    
    # build widget .index_ctrl.middle.bottom.how2delete.radiobutton11
    radiobutton .index_ctrl.middle.bottom.how2delete.radiobutton11 \
	    -relief {flat} \
	    -text {only from the list} \
	    -value {list} \
	    -variable {idx_delete_mode}

    # pack widget .index_ctrl.middle.bottom.how2delete
    pack append .index_ctrl.middle.bottom.how2delete \
	    .index_ctrl.middle.bottom.how2delete.label9 {top frame w} \
	    .index_ctrl.middle.bottom.how2delete.radiobutton10 {top frame w} \
	    .index_ctrl.middle.bottom.how2delete.radiobutton11 {top frame w}
    
    # build widget .index_ctrl.middle.bottom.how1
    frame .index_ctrl.middle.bottom.how2add \
	    -borderwidth {2}
    
    # build widget .index_ctrl.middle.bottom.how2add.label9
    label .index_ctrl.middle.bottom.how2add.label9 \
	    -borderwidth {0} \
	    -text {Add:}
    
    # build widget .index_ctrl.middle.bottom.how2add.radiobutton10
    radiobutton .index_ctrl.middle.bottom.how2add.radiobutton10 \
	    -relief {flat} \
	    -text {to list and file} \
	    -value {list_and_file} \
	    -variable {idx_add_mode}
    
    # build widget .index_ctrl.middle.bottom.how2add.radiobutton11
    radiobutton .index_ctrl.middle.bottom.how2add.radiobutton11 \
	    -relief {flat} \
	    -text {only to the list} \
	    -value {list} \
	    -variable {idx_add_mode}
    
    # pack widget .index_ctrl.middle.bottom.how2add
    pack append .index_ctrl.middle.bottom.how2add \
	    .index_ctrl.middle.bottom.how2add.label9 {top frame w} \
	    .index_ctrl.middle.bottom.how2add.radiobutton10 {top frame w} \
	    .index_ctrl.middle.bottom.how2add.radiobutton11 {top frame w}
    
    # pack widget .index_ctrl.middle.bottom
    pack append .index_ctrl.middle.bottom \
	    .index_ctrl.middle.bottom.how2delete {right frame center padx 20} \
	    .index_ctrl.middle.bottom.how2add {left frame center padx 30}
    
    # pack widget .index_ctrl.middle
    pack append .index_ctrl.middle \
	    .index_ctrl.middle.media_desc {top frame center pady 10 fillx} \
	    .index_ctrl.middle.index_list {top frame center expand fill} \
	    .index_ctrl.middle.index_cmds {top frame center pady 10 fillx} \
	    .index_ctrl.middle.levels {top frame center pady 10 fillx} \
	    .index_ctrl.middle.skip_cmds {top frame center expand fillx pady 10} \
	    .index_ctrl.middle.skip_desc {top frame center expand fillx} \
	    .index_ctrl.middle.bottom {top frame center expand fillx}
    
    # build widget .index_ctrl.bottom
    frame .index_ctrl.bottom \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .index_ctrl.bottom.dismiss
    button .index_ctrl.bottom.dismiss \
	    -text {Dismiss} \
	    -command {
	catch {destroy .index_ctrl}
	set session(index_ctrl) "0"
    }
    
    # pack widget .index_ctrl.bottom
    pack append .index_ctrl.bottom \
	    .index_ctrl.bottom.dismiss {top frame center padx 20 pady 20}
    
    # pack widget .index_ctrl
    pack append .index_ctrl \
	    .index_ctrl.top {top frame center fillx} \
	    .index_ctrl.middle {top frame center expand fill} \
	    .index_ctrl.bottom {top frame center fillx}
    
    .index_ctrl.middle.index_list.listbox insert end {- none -}
    .index_ctrl.middle.index_cmds.delete configure -state disabled
    
    switch_media $session(index_media)
    update_index_menu
    if { $session(state) == "recording" } {
	set_index_rec
    }
    
}


proc can_use_index {} {
    global VERSION session 
    if {$session(loaded) == "0"} {
	AlertBox "\n $VERSION error: \n\n No session loaded. \n" "" ""\
		"$VERSION (Index Control)" Ok
	return "0"
    } 
    if {$session(index_media) == "0"} {
	AlertBox "\n $VERSION error: \n\n No index media selected. \n" "" ""\
		"$VERSION (Index Control)" Ok
	return "0"
    }
    return "1"
}

proc can_write_index {} {
    global VERSION session 
    if {[can_use_index] == "0"} {return 0}
    if {$session(read_only) == "1"} {
	AlertBox "\n $VERSION error: \n\n This session is read only. \n" "" ""\
		"$VERSION (Index Control)" Ok
	return "0"
    } 
    return "1"
}

proc add_index { {index_entries ""} } {
    global session index_list new_index_list nb_of_indices

    if { $index_entries == "" } { return }
    if { [llength $index_entries] == "0" } { return }

    for { set entry_nb 0 } { $entry_nb < [llength $index_entries] } { incr entry_nb } {
	set index_entry [lindex $index_entries $entry_nb]
	if { [lsearch $new_index_list $index_entry] == "-1" } {
	    set new_index_list\
		    [lappend new_index_list $index_entry]
	    set nb_of_indices($session(index_media))\
		    [expr $nb_of_indices($session(index_media))+1]
	}
    }
}


proc idx_cmp { arg1 arg2 } {
    if { [lindex $arg1 0] < [lindex $arg2 0] } {
	return -1 
    } elseif { [lindex $arg1 0] == [lindex $arg2 0] } {
	return 0
    } else {
	return 1
    }
}

proc switch_media { { j "0" } { label "" } } {
    global session tmp_session index_list nb_of_indices auto_blank_skip_time

    set session(index_media) $j
    set tmp_session(index_media) $j

    if { ($j==0) && ($auto_blank_skip_time > 0)} {
	no_auto_blank_skip
	AlertBox "\n $VERSION info: \n\n Auto Blank Skip turned off. \n" "" ""\
		"$VERSION" Ok
    }

    if { $label == "" } {
	if { $session(index_media) > 0 } {
	    if {$session(media_list,$j,media_desc) != ""} {
		set label [format "%s (%s)" $session(media_list,$j,media_name) \
			$session(media_list,$j,media_desc)]
	    } else {
		set label $session(media_list,$j,media_name)
	    }
	} else {
	    set label "- none -"
	}
    }

    .vcr.middle.right.index_ctrl.media_desc.media_display configure -text "$label"

    if { [winfo exists .index_ctrl] == "1" } {
	.index_ctrl.middle.media_desc.media_display configure -text "$label"

	if { $session(index_media) == 0 } {
	    .index_ctrl.middle.media_desc.media_display configure -text "- none -"
	    .index_ctrl.middle.index_list.listbox delete 0 end
	    .index_ctrl.middle.index_list.listbox insert end "- none -"
	    set nb_of_indices(0) 0
	} else {
	    if { ($nb_of_indices($session(index_media)) == 0) } {
		.index_ctrl.middle.index_list.listbox delete 0 end
		.index_ctrl.middle.index_list.listbox insert end "- none -"
	    } else {
		.index_ctrl.middle.index_list.listbox delete 0 end
		for {set i 0} { $i < $nb_of_indices($session(index_media)) } { incr i } {
		    .index_ctrl.middle.index_list.listbox insert end \
			    [lrange [lindex $index_list($session(index_media)) $i] 2 end]
		}
	    }
	    .index_ctrl.middle.index_list.listbox delete 0 end
	    for { set i 0} { $i < $nb_of_indices($session(index_media))} { incr i } {
		.index_ctrl.middle.index_list.listbox insert end \
			[lrange [lindex $index_list($session(index_media)) $i] 2 end]
	    }
	    if {[.index_ctrl.middle.index_list.listbox size] == 0} {
		.index_ctrl.middle.index_cmds.delete configure -state disabled
		.index_ctrl.middle.index_list.listbox insert end "- none -"
	    } else {
		.index_ctrl.middle.index_cmds.delete configure -state normal
	    }
	}
    }
    
}

# procedure to show window .get_indices
proc get_indices {args} {
    global VERSION session index_values get_idx where2start add_to_list index_list
    global new_index_list nb_of_indices curr_time
    
    if {[can_write_index] == "0"} {return 0}

    # build widget .get_indices
    toplevel .get_indices  \
	    -relief {raised}
    
    # Window manager configurations
    global tk_version
    wm positionfrom .get_indices program
    wm sizefrom .get_indices program
    wm title .get_indices "$VERSION (Get Indices)"
    
    
    # build widget .get_indices.top
    frame .get_indices.top \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .get_indices.top.title
    label .get_indices.top.title \
	    -text {Choose index levels to look for:}

    # pack widget .get_indices.top
    pack append .get_indices.top \
	    .get_indices.top.title {top frame center padx 5 pady 5 expand}
    
    # build widget .get_indices.middle
    frame .get_indices.middle \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .get_indices.middle.top
    frame .get_indices.middle.top \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .get_indices.middle.top.left
    frame .get_indices.middle.top.left
    
    # build widget .get_indices.middle.top.middle
    frame .get_indices.middle.top.middle
    
    checkbutton .get_indices.middle.top.middle.checkbutton1\
	    -text "new sync unit" \
	    -relief {flat} \
	    -variable "get_idx(1)"
    
    checkbutton .get_indices.middle.top.middle.checkbutton2 \
	    -text "new speaker" \
	    -relief {flat} \
	    -variable "get_idx(2)"
    
    checkbutton .get_indices.middle.top.middle.checkbutton3 \
	    -text "new format" \
	    -relief {flat} \
	    -variable "get_idx(3)"
    
    for {set i 1} { $i <= 5 } {incr i} {
	checkbutton .get_indices.middle.top.middle.checkbutton[expr 3 + $i] \
		-text "user level $i" \
		-relief {flat} \
		-variable "get_idx([expr 3 + $i])"
    }
    
    checkbutton .get_indices.middle.top.middle.checkbutton9 \
	    -text "all indices" \
	    -relief {flat} \
	    -variable "get_idx(9)"

    for {set i 1} { $i <= 9 } {incr i} {
	# pack widget .get_indices.middle.top.middle
	pack append .get_indices.middle.top.middle \
		.get_indices.middle.top.middle.checkbutton$i {top frame w}
    }
     

    # build widget .get_indices.middle.top.right
    frame .get_indices.middle.top.right 
    
    # pack widget .get_indices.middle.top
    pack append .get_indices.middle.top \
	    .get_indices.middle.top.left {left frame w padx 65 pady 20} \
	    .get_indices.middle.top.middle {left frame w pady 20} \
	    .get_indices.middle.top.right {left frame w padx 60 pady 20}
    
    # build widget .get_indices.middle.bottom
    frame .get_indices.middle.bottom \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .get_indices.middle.bottom.max
    frame .get_indices.middle.bottom.max
    
    # build widget .get_indices.middle.bottom.max.label
    label .get_indices.middle.bottom.max.label \
	    -padx {2} \
	    -text {Max nb of indices:} \
	    -width {15}
    
    # build widget .get_indices.middle.bottom.max.entry
    entry .get_indices.middle.bottom.max.entry \
	    -relief {sunken} \
	    -width {6} \
	    -textvariable {max_indices}
    
    # pack widget .get_indices.middle.bottom.max
    pack append .get_indices.middle.bottom.max \
	    .get_indices.middle.bottom.max.label {left frame w} \
	    .get_indices.middle.bottom.max.entry {left frame w}
    
    # build widget .get_indices.middle.bottom.add2current
    frame .get_indices.middle.bottom.add2current
    
    # build widget .get_indices.middle.bottom.add2current.label
    label .get_indices.middle.bottom.add2current.label \
	    -text {Add indices to current list?}
    
    # build widget .get_indices.middle.bottom.add2current.yes
    radiobutton .get_indices.middle.bottom.add2current.yes \
	    -relief {flat} \
	    -text {yes} \
	    -value {1} \
	    -variable {add_to_list}
    
    # build widget .get_indices.middle.bottom.add2current.no
    radiobutton .get_indices.middle.bottom.add2current.no \
	    -relief {flat} \
	    -text {no} \
	    -value {0} \
	    -variable {add_to_list}
    
    # pack widget .get_indices.middle.bottom.add2current
    pack append .get_indices.middle.bottom.add2current \
	    .get_indices.middle.bottom.add2current.label {top frame w} \
	    .get_indices.middle.bottom.add2current.yes {top frame w} \
	    .get_indices.middle.bottom.add2current.no {top frame w}
    
    # build widget .get_indices.middle.bottom.where2start
    frame .get_indices.middle.bottom.where2start
    
    # build widget .get_indices.middle.bottom.where2start.label
    label .get_indices.middle.bottom.where2start.label \
	    -text {Start searching at:}
    
    # build widget .get_indices.middle.bottom.where2start.beginning
    radiobutton .get_indices.middle.bottom.where2start.beginning \
	    -relief {flat} \
	    -text {beginning of the file} \
	    -value {1} \
	    -variable {where2start}
    
    # build widget .get_indices.middle.bottom.where2start.current_pos
    radiobutton .get_indices.middle.bottom.where2start.current_pos \
	    -relief {flat} \
	    -text "current position ($curr_time)" \
	    -value {0} \
	    -variable {where2start}
    
    # pack widget .get_indices.middle.bottom.where2start
    pack append .get_indices.middle.bottom.where2start \
	    .get_indices.middle.bottom.where2start.label {top frame w} \
	    .get_indices.middle.bottom.where2start.beginning {top frame w} \
	    .get_indices.middle.bottom.where2start.current_pos {top frame w} 
    
    # build widget .get_indices.middle.bottom.frame0
    frame .get_indices.middle.bottom.fill \
	    -borderwidth {2} \
	    -width {30} \
	    -height {30}
    
    # pack widget .get_indices.middle.bottom
    pack append .get_indices.middle.bottom \
	    .get_indices.middle.bottom.fill {left frame center} \
	    .get_indices.middle.bottom.max {top frame w padx 25 pady 10} \
	    .get_indices.middle.bottom.add2current {top frame w padx 20 pady 10} \
	    .get_indices.middle.bottom.where2start {top frame w padx 20 pady 10}
    
    # pack widget .get_indices.middle
    pack append .get_indices.middle \
	    .get_indices.middle.top {top frame center pady 10 expand} \
	    .get_indices.middle.bottom {top frame center expand}
    
    # build widget .get_indices.bottom
    frame .get_indices.bottom \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .get_indices.bottom.ok
    button .get_indices.bottom.ok \
	    -text {Ok} \
	    -width {15}\
	    -command {
	set idx 0
	if { $get_idx(9) == "1" } {
	    set idx 255
	} else {
	    for {set i 1} { $i <= 8 } {incr i} {
		if { $get_idx($i) == "1" } {
		    case $i in {
			{1} {
			    set idx [expr $idx | $index_values(NEW_TS)]
			}
			{2} {
			    set idx [expr $idx | $index_values(NEW_SP)]
			}
			{3} {
			    set idx [expr $idx | $index_values(NEW_FMT)]
			}
			{default} {
			    set idx [expr $idx | $index_values(USER[expr $i - 3])]
			} 
		    }
		}
	    }
	}
	set new_idx 0
	if  { $add_to_list == "1" } {
	    set new_index_list $index_list($session(index_media))
	    set max [expr $max_indices + [llength $index_list($session(index_media))]]
	} else {
	    set new_index_list {}
	    set max $max_indices
	}
	set index_entries [vcr_ctrl index get_first $session(index_media) $idx $where2start]
	while { ($index_entries != "") && ([llength $new_index_list] < $max) } {
	    add_index "$index_entries"
	    set index_entries [vcr_ctrl index get_next $session(index_media) $idx]
	}
	update_index_listbox
	vcr_grab release .get_indices
	set session(index_ctrl) "0"
	catch {destroy .get_indices}
    }
    
    # build widget .get_indices.bottom.cancel
    button .get_indices.bottom.cancel \
	    -text {Cancel} \
	    -width {15} \
	    -command {
	vcr_grab release .get_indices
	set session(index_ctrl) "0"
	catch {destroy .get_indices}
    }
    
    # pack widget .get_indices.bottom
    pack append .get_indices.bottom \
	    .get_indices.bottom.ok {left frame center padx 10 pady 10} \
	    .get_indices.bottom.cancel {right frame center padx 10 pady 10}
    
    # pack widget .get_indices
    pack append .get_indices \
	    .get_indices.top {top frame center padx 10 pady 10 expand fill} \
	    .get_indices.middle {top frame center padx 20 pady 20 expand fill} \
	    .get_indices.bottom {top frame center padx 10 pady 10 expand fill}
    
    vcr_grab .get_indices
}

proc delete_indices {{selection ""}} {
    global idx_delete_mode index_list session nb_of_indices

    set offset 0
    foreach index $selection {
	if {$idx_delete_mode == "list_and_file" } {
	    set ret [vcr_ctrl index delete $session(index_media)\
		    [lindex [lindex $index_list($session(index_media))\
		    [expr $index - $offset]] 0]\
		    [lindex [lindex $index_list($session(index_media))\
		    [expr $index-$offset]] 1]]
	} else {
	    set ret 1
	}
	if { $ret == 1} {
	    .index_ctrl.middle.index_list.listbox delete [expr $index - $offset]
	    set index_list($session(index_media)) [concat \
		    [lrange $index_list($session(index_media)) 0 [expr $index-$offset-1]]\
		    [lrange $index_list($session(index_media)) [expr $index-$offset+1] end]]
	    set nb_of_indices($session(index_media)) \
		    [expr $nb_of_indices($session(index_media))-1]
	    set offset [expr $offset + 1]
	}
    }
    if {[.index_ctrl.middle.index_list.listbox size] == 0} {
	.index_ctrl.middle.index_cmds.delete configure -state disabled
	.index_ctrl.middle.index_list.listbox insert end "- none -"
    }
}

proc delete_all_indices {args} {
    global VERSION session index_values del_idx idx_delete_mode index_list new_index_list curr_time where2start
    
    if {[can_write_index] == "0"} {return 0}
    
    toplevel .delete_all_indices  \
	    -relief {raised}
    
    # Window manager configurations
    global tk_version
    wm positionfrom .delete_all_indices program
    wm sizefrom .delete_all_indices program
    wm title .delete_all_indices {MBone VCR v1.0tcl (Delete Indices)}
    
    
    # build widget .delete_all_indices.top
    frame .delete_all_indices.top \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .delete_all_indices.top.title
    label .delete_all_indices.top.title \
	    -text {Choose indices to delete}
    
    # pack widget .delete_all_indices.top
    pack append .delete_all_indices.top \
	    .delete_all_indices.top.title {top frame center padx 5 pady 5 expand}
    
    # build widget .delete_all_indices.middle
    frame .delete_all_indices.middle \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .delete_all_indices.middle.top
    frame .delete_all_indices.middle.top \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .delete_all_indices.middle.top.left
    frame .delete_all_indices.middle.top.left
    
    # build widget .delete_all_indices.middle.top.middle
    frame .delete_all_indices.middle.top.middle
    
    # build widget .delete_all_indices.middle.top.middle.checkbutton1
    checkbutton .delete_all_indices.middle.top.middle.checkbutton1 \
	    -relief {flat} \
	    -text {new sync unit} \
	    -variable {del_idx(1)}
    
    # build widget .delete_all_indices.middle.top.middle.checkbutton2
    checkbutton .delete_all_indices.middle.top.middle.checkbutton2 \
	    -relief {flat} \
	    -text {new speaker} \
	    -variable {del_idx(2)}
    
    # build widget .delete_all_indices.middle.top.middle.checkbutton3
    checkbutton .delete_all_indices.middle.top.middle.checkbutton3 \
	    -relief {flat} \
	    -text {new format} \
	    -variable {del_idx(3)}
    
    for {set i 1} { $i <= 5 } {incr i} {
	checkbutton .delete_all_indices.middle.top.middle.checkbutton[expr 3 + $i] \
		-text "user level $i" \
		-relief {flat} \
		-variable "del_idx([expr 3 + $i])"
    }
    
    for {set i 1} { $i <= 8 } {incr i} {
	# pack widget .delete_all_indices.middle.top.middle
	pack append .delete_all_indices.middle.top.middle \
		.delete_all_indices.middle.top.middle.checkbutton$i {top frame w}
    }
    
    # build widget .delete_all_indices.middle.top.right
    frame .delete_all_indices.middle.top.right
    
    # pack widget .delete_all_indices.middle.top
    pack append .delete_all_indices.middle.top \
	    .delete_all_indices.middle.top.left {left frame w padx 65} \
	    .delete_all_indices.middle.top.middle {left frame w pady 10 expand} \
	    .delete_all_indices.middle.top.right {left frame w padx 55}
    
    # build widget .delete_all_indices.middle.bottom
    frame .delete_all_indices.middle.bottom \
	    -borderwidth {2} \
	    -relief {groove}
    
    # build widget .delete_all_indices.middle.bottom.how2delete
    frame .delete_all_indices.middle.bottom.how2delete \
	    -borderwidth {2}
    
    # build widget .delete_all_indices.middle.bottom.how2delete.label9
    label .delete_all_indices.middle.bottom.how2delete.label9 \
	    -borderwidth {0} \
	    -text {Delete:}
    
    # build widget .delete_all_indices.middle.bottom.how2delete.radiobutton10
    radiobutton .delete_all_indices.middle.bottom.how2delete.radiobutton10 \
	    -relief {flat} \
	    -text {from list and file} \
	    -value {list_and_file} \
	    -variable {idx_delete_mode}
    
    # build widget .delete_all_indices.middle.bottom.how2delete.radiobutton11
    radiobutton .delete_all_indices.middle.bottom.how2delete.radiobutton11 \
	    -relief {flat} \
	    -text {only from the list} \
	    -value {list} \
	    -variable {idx_delete_mode}
    
    # pack widget .delete_all_indices.middle.bottom.how2delete
    pack append .delete_all_indices.middle.bottom.how2delete \
	    .delete_all_indices.middle.bottom.how2delete.label9 {top frame w} \
	    .delete_all_indices.middle.bottom.how2delete.radiobutton10 {top frame w} \
	    .delete_all_indices.middle.bottom.how2delete.radiobutton11 {top frame w}
    
    # build widget .get_indices.middle.bottom.where2start
    frame .delete_all_indices.middle.bottom.where2start
    
    # build widget .delete_all_indices.middle.bottom.where2start.label
    label .delete_all_indices.middle.bottom.where2start.label \
	    -text {Start deleting at:}
    
    # build widget .delete_all_indices.middle.bottom.where2start.beginning
    radiobutton .delete_all_indices.middle.bottom.where2start.beginning \
	    -relief {flat} \
	    -text {beginning of the file} \
	    -value {1} \
	    -variable {where2start}
    
    # build widget .delete_all_indices.middle.bottom.where2start.current_pos
    radiobutton .delete_all_indices.middle.bottom.where2start.current_pos \
	    -relief {flat} \
	    -text "current position ($curr_time)" \
	    -value {0} \
	    -variable {where2start}
    
    # pack widget .delete_all_indices.middle.bottom.where2start
    pack append .delete_all_indices.middle.bottom.where2start \
	    .delete_all_indices.middle.bottom.where2start.label {top frame w} \
	    .delete_all_indices.middle.bottom.where2start.beginning {top frame w} \
	    .delete_all_indices.middle.bottom.where2start.current_pos {top frame w} 
    
    # build widget .delete_all_indices.middle.bottom.fill
    frame .delete_all_indices.middle.bottom.fill \
	    -borderwidth {2} \
	    -width {30} \
	    -height {30}
    
    # pack widget .delete_all_indices.middle.bottom
    pack append .delete_all_indices.middle.bottom \
	    .delete_all_indices.middle.bottom.how2delete {top frame center padx 67} \
	    .delete_all_indices.middle.bottom.where2start {top frame center} \
	    .delete_all_indices.middle.bottom.fill {left frame center}
    
    # pack widget .delete_all_indices.middle
    pack append .delete_all_indices.middle \
	    .delete_all_indices.middle.top {top frame center expand} \
	    .delete_all_indices.middle.bottom {top frame center expand}
    
    # build widget .delete_all_indices.bottom
    frame .delete_all_indices.bottom \
	    -borderwidth {2} \
	    -relief {raised}
    
    # build widget .delete_all_indices.bottom.ok
    button .delete_all_indices.bottom.ok \
	    -text {Ok} \
	    -width {15} \
	    -command {
	set idx 0
	for {set i 1} { $i <= 8 } {incr i} {
	    if { $del_idx($i) == "1" } {
		case $i in {
		    {1} {
			set idx [expr $idx | $index_values(NEW_TS)]
		    }
		    {2} {
			set idx [expr $idx | $index_values(NEW_SP)]
		    }
		    {3} {
			set idx [expr $idx | $index_values(NEW_FMT)]
		    }
		    {default} {
			set idx [expr $idx | $index_values(USER[expr $i - 3])]
		    } 
		}
	    }
	}
	
	set selection ""
	set curr_ts [vcr_ctrl get_ts] 
	for { set i 0 } { $i < [llength $index_list($session(index_media))] } { incr i } {
	    set x [expr [lindex [lindex $index_list($session(index_media)) $i] 1] & $idx]
	    if { ($x !=0) && ($where2start == 0) } {
		if { [lindex [lindex $index_list($session(index_media)) $i] 0] < $curr_ts } {
		    set x 0
		}
	    }
	    if { $x != 0 } {
		set selection [format "%s %d" $selection $i]
	    }
	}
	set selection [string trim $selection]
	delete_indices $selection
	vcr_grab release .delete_all_indices
	catch {destroy .delete_all_indices}
    }
    
    # build widget .delete_all_indices.bottom.cancel
    button .delete_all_indices.bottom.cancel \
	    -text {Cancel} \
	    -width {15}\
	    -command {
	vcr_grab release .delete_all_indices
	catch {destroy .delete_all_indices}
    } 
    
    # pack widget .delete_all_indices.bottom
    pack append .delete_all_indices.bottom \
	    .delete_all_indices.bottom.ok {left frame center padx 10 pady 10} \
	    .delete_all_indices.bottom.cancel {right frame center padx 10 pady 10}
    
    # pack widget .delete_all_indices
    pack append .delete_all_indices \
	    .delete_all_indices.top {top frame center padx 10 pady 10 expand fill} \
	    .delete_all_indices.middle {top frame center padx 20 pady 20 expand fill} \
	    .delete_all_indices.bottom {top frame center padx 10 pady 10 expand fill}

    vcr_grab .delete_all_indices
}

proc bind_click_on_index {} {
    bind .index_ctrl.middle.index_list.listbox <Double-Button-1> {
	global VERSION session index_list
	
	set index_nb [.index_ctrl.middle.index_list.listbox curselection]
	
	if {([llength "$index_nb"] == 0) || \
		([.index_ctrl.middle.index_list.listbox get 0] == "- none -")} {
	    AlertBox "\n $VERSION error: \n\n No index selected. \n" "" ""\
		    "$VERSION (Index Control)" Ok
	} elseif { [llength "$index_nb"] > 1 } {
	    AlertBox "\n $VERSION error: \n\n More than one index selected. \n" "" ""\
		    "$VERSION (Index Control)" Ok
	} else {
	    set session(state) \
		    [vcr_ctrl goto ms \
		    [lindex [lindex $index_list($session(index_media)) $index_nb] 0] ]
	}
    }
}

proc set_index_rec {} {
    if { [winfo exists .index_ctrl] == 1 } {
	.index_ctrl.middle.index_cmds.get configure -state disabled
	if { [winfo exists .get_indices] } {
	    destroy .get_indices
	}
	.index_ctrl.middle.index_cmds.delete configure -state disabled
	.index_ctrl.middle.index_cmds.delete_all configure -state disabled
	if { [winfo exists .delete_all_indices] } {
	    destroy .delete_all_indices
	}
	.index_ctrl.middle.skip_cmds.prev_index configure -state disabled
	.index_ctrl.middle.skip_cmds.prev_ts configure -state disabled
	.index_ctrl.middle.skip_cmds.prev_speaker configure -state disabled
	.index_ctrl.middle.skip_cmds.next_index configure -state disabled
	.index_ctrl.middle.skip_cmds.next_ts configure -state disabled
	.index_ctrl.middle.skip_cmds.next_speaker configure -state disabled
	bind .index_ctrl.middle.index_list.listbox <Double-Button-1> {}
	
    }
}

proc set_index_normal {} {
    if { [winfo exists .index_ctrl] == 1 } {
	.index_ctrl.middle.index_cmds.get configure -state normal
	.index_ctrl.middle.index_cmds.delete configure -state normal
	.index_ctrl.middle.index_cmds.delete_all configure -state normal
	.index_ctrl.middle.skip_cmds.prev_index configure -state normal
	.index_ctrl.middle.skip_cmds.prev_ts configure -state normal
	.index_ctrl.middle.skip_cmds.prev_speaker configure -state normal
	.index_ctrl.middle.skip_cmds.next_index configure -state normal
	.index_ctrl.middle.skip_cmds.next_ts configure -state normal
	.index_ctrl.middle.skip_cmds.next_speaker configure -state normal
	bind_click_on_index
    }
}


proc update_index_menu {{local_only "0"}} {
    global tmp_session session nb_of_indices index_list auto_blank_skip_time

    if { $local_only == "0" } {
	fill_tmp_session
	.vcr.middle.right.index_ctrl.media_desc.mediabutton.m delete 0 last
    }
    if {[winfo exists .index_ctrl] == "1"} {
	.index_ctrl.middle.media_desc.mediabutton.m delete 0 last
    }
    for {set i 0} {$i <= $tmp_session(nb_of_media)} {incr i} {
	if { $i > 0 } {
	    if {$tmp_session(media_list,$i,media_desc) != ""} {
		set label [format "%s (%s)" \
			$tmp_session(media_list,$i,media_name) \
			$tmp_session(media_list,$i,media_desc)]
	    } else {
		set label $tmp_session(media_list,$i,media_name)
	    }
	} else {
	    set label "- none -"
	}

	if {[winfo exists .index_ctrl] == "1"} {
	    .index_ctrl.middle.media_desc.mediabutton.m add command \
		    -label "$label" \
		    -command "switch_media $i \"$label\""
	}
	if { $local_only == "0" } {
	    .vcr.middle.right.index_ctrl.media_desc.mediabutton.m add command \
		    -label "$label" \
		    -command "switch_media $i \"$label\""
	}
    }
    if { $session(loaded) == 1 } {
	vcr_ctrl set_auto_blank_skip $session(index_media) $auto_blank_skip_time
    }
}

proc update_index_listbox {} {
    global session index_list new_index_list nb_of_indices

    set new_index_list [lsort -command idx_cmp $new_index_list]
    set index_list($session(index_media)) $new_index_list
    set nb_of_indices($session(index_media)) [llength $new_index_list]

    .index_ctrl.middle.index_list.listbox delete 0 end
    for { set i 0} { $i < [llength $new_index_list]} { incr i } {
	.index_ctrl.middle.index_list.listbox insert end \
		[lrange [lindex $new_index_list $i] 2 end]
    }
    if {[.index_ctrl.middle.index_list.listbox size] == 0} {
	.index_ctrl.middle.index_cmds.delete configure -state disabled
	.index_ctrl.middle.index_list.listbox insert end "- none -"
    } else {
	.index_ctrl.middle.index_cmds.delete configure -state normal
    }
}

# eof
#
