#/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#
# Copyright (c) 1995 International Computer Science Institute
# All Rights Reserved.
#
# Created by Wieland Holfelder (whd@icsi.berkeley.edu)
# Tenet Group
# International Computer Science Institute
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for educational, research and non-profit purposes,
# without fee, and without a written agreement is hereby granted,
# provided that the above copyright notice, this paragraph and the
# following five paragraphs appear in all copies.
#
# Permission to incorporate this software into commercial products may
# be obtained from the International Computer Science Institute,
# 1947 Center Street, Suite 600, Berkeley, CA 94704.
#
# IN NO EVENT SHALL THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE BE
# LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR
# CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE
# USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS BEEN ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# THE INTERNATIONAL COMPUTER SCIENCE INSTITUTE SPECIFICALLY DISCLAIMS
# ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE INTERNATIONAL
# COMPUTER SCIENCE INSTITUTE  HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE,
# SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
#
# The International Computer Science Institute will appreciate
# receiving any enhancements and modifications of this software
# made by others, and reserves the right to include them in future
# releases. The Institute also recommends that this software not
# be redistributed by third parties, but be obtained by all directly
# from the ICSI server, so that all users of the software may
# receive bug notifications and other relevant announcements.
#
# The German Academic Exchange Service has supported the development
# of this software. Their support is gratefully acknowledged.
#
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#
# $Id: num_display.tcl,v 1.1 1996/07/26 12:12:57 whd Exp $ (ICSI)
#
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

global num_display
set num_display ""
global curr_time
set curr_time "00:00:00"


proc InitNumDispCurrValue {} {

  global {num_disp_curr_value}

  set {num_disp_curr_value(1,1)} {-1}
  set {num_disp_curr_value(1,2)} {-1}
  set {num_disp_curr_value(1,3)} {-1}
  set {num_disp_curr_value(1,4)} {-1}
  set {num_disp_curr_value(1,5)} {-1}
  set {num_disp_curr_value(1,6)} {-1}
  set {num_disp_curr_value(1,7)} {-1}
  set {num_disp_curr_value(1,8)} {-1}

  set {num_disp_curr_value(2,1)} {-1}
  set {num_disp_curr_value(2,2)} {-1}
  set {num_disp_curr_value(2,3)} {-1}
  set {num_disp_curr_value(2,4)} {-1}
  set {num_disp_curr_value(2,5)} {-1}
  set {num_disp_curr_value(2,6)} {-1}
  set {num_disp_curr_value(2,7)} {-1}
  set {num_disp_curr_value(2,8)} {-1}

  set {num_disp_curr_value(3,1)} {-1}
  set {num_disp_curr_value(3,2)} {-1}
  set {num_disp_curr_value(3,3)} {-1}
  set {num_disp_curr_value(3,4)} {-1}
  set {num_disp_curr_value(3,5)} {-1}
  set {num_disp_curr_value(3,6)} {-1}
  set {num_disp_curr_value(3,7)} {-1}
  set {num_disp_curr_value(3,8)} {-1}

  set {num_disp_curr_value(4,1)} {-1}
  set {num_disp_curr_value(4,2)} {-1}
  set {num_disp_curr_value(4,3)} {-1}
  set {num_disp_curr_value(4,4)} {-1}
  set {num_disp_curr_value(4,5)} {-1}
  set {num_disp_curr_value(4,6)} {-1}
  set {num_disp_curr_value(4,7)} {-1}
  set {num_disp_curr_value(4,8)} {-1}

  set {num_disp_curr_value(5,1)} {-1}
  set {num_disp_curr_value(5,2)} {-1}
  set {num_disp_curr_value(5,3)} {-1}
  set {num_disp_curr_value(5,4)} {-1}
  set {num_disp_curr_value(5,5)} {-1}
  set {num_disp_curr_value(5,6)} {-1}
  set {num_disp_curr_value(5,7)} {-1}
  set {num_disp_curr_value(5,8)} {-1}

  set {num_disp_curr_value(6,1)} {-1}
  set {num_disp_curr_value(6,2)} {-1}
  set {num_disp_curr_value(6,3)} {-1}
  set {num_disp_curr_value(6,4)} {-1}
  set {num_disp_curr_value(6,5)} {-1}
  set {num_disp_curr_value(6,6)} {-1}
  set {num_disp_curr_value(6,7)} {-1}
  set {num_disp_curr_value(6,8)} {-1}

  set {num_disp_curr_value(7,1)} {-1}
}

proc InitNumDispValues {} {

    global {num_disp_values}

    set {num_disp_values(0,1)} {1}
    set {num_disp_values(0,2)} {1}
    set {num_disp_values(0,3)} {1}
    set {num_disp_values(0,4)} {1}
    set {num_disp_values(0,5)} {1}
    set {num_disp_values(0,6)} {1}
    set {num_disp_values(0,7)} {0}

    set {num_disp_values(1,1)} {0}
    set {num_disp_values(1,2)} {0}
    set {num_disp_values(1,3)} {0}
    set {num_disp_values(1,4)} {0}
    set {num_disp_values(1,5)} {1}
    set {num_disp_values(1,6)} {1}
    set {num_disp_values(1,7)} {0}

    set {num_disp_values(2,1)} {1}
    set {num_disp_values(2,2)} {0}
    set {num_disp_values(2,3)} {1}
    set {num_disp_values(2,4)} {1}
    set {num_disp_values(2,5)} {0}
    set {num_disp_values(2,6)} {1}
    set {num_disp_values(2,7)} {1}

    set {num_disp_values(3,1)} {1}
    set {num_disp_values(3,2)} {0}
    set {num_disp_values(3,3)} {0}
    set {num_disp_values(3,4)} {1}
    set {num_disp_values(3,5)} {1}
    set {num_disp_values(3,6)} {1}
    set {num_disp_values(3,7)} {1}

    set {num_disp_values(4,1)} {0}
    set {num_disp_values(4,2)} {1}
    set {num_disp_values(4,3)} {0}
    set {num_disp_values(4,4)} {0}
    set {num_disp_values(4,5)} {1}
    set {num_disp_values(4,6)} {1}
    set {num_disp_values(4,7)} {1}

    set {num_disp_values(5,1)} {1}
    set {num_disp_values(5,2)} {1}
    set {num_disp_values(5,3)} {0}
    set {num_disp_values(5,4)} {1}
    set {num_disp_values(5,5)} {1}
    set {num_disp_values(5,6)} {0}
    set {num_disp_values(5,7)} {1}

    set {num_disp_values(6,1)} {1}
    set {num_disp_values(6,2)} {1}
    set {num_disp_values(6,3)} {1}
    set {num_disp_values(6,4)} {1}
    set {num_disp_values(6,5)} {1}
    set {num_disp_values(6,6)} {0}
    set {num_disp_values(6,7)} {1}

    set {num_disp_values(7,1)} {1}
    set {num_disp_values(7,2)} {0}
    set {num_disp_values(7,3)} {0}
    set {num_disp_values(7,4)} {0}
    set {num_disp_values(7,5)} {1}
    set {num_disp_values(7,6)} {1}
    set {num_disp_values(7,7)} {0}

    set {num_disp_values(8,1)} {1}
    set {num_disp_values(8,2)} {1}
    set {num_disp_values(8,3)} {1}
    set {num_disp_values(8,4)} {1}
    set {num_disp_values(8,5)} {1}
    set {num_disp_values(8,6)} {1}
    set {num_disp_values(8,7)} {1}

    set {num_disp_values(9,1)} {1}
    set {num_disp_values(9,2)} {1}
    set {num_disp_values(9,3)} {0}
    set {num_disp_values(9,4)} {1}
    set {num_disp_values(9,5)} {1}
    set {num_disp_values(9,6)} {1}
    set {num_disp_values(9,7)} {1}

    set {num_disp_values(10,1)} {1}
    set {num_disp_values(10,2)} {2}
    set {num_disp_values(10,3)} {3}
    set {num_disp_values(10,4)} {0}
    set {num_disp_values(10,5)} {1}
    set {num_disp_values(10,6)} {1}
    set {num_disp_values(10,7)} {1}

    set {num_disp_values(11,1)} {0}
    set {num_disp_values(11,2)} {1}
    set {num_disp_values(11,3)} {1}
    set {num_disp_values(11,4)} {1}
    set {num_disp_values(11,5)} {1}
    set {num_disp_values(11,6)} {0}
    set {num_disp_values(11,7)} {1}

    set {num_disp_values(12,1)} {1}
    set {num_disp_values(12,2)} {1}
    set {num_disp_values(12,3)} {1}
    set {num_disp_values(12,4)} {1}
    set {num_disp_values(12,5)} {0}
    set {num_disp_values(12,6)} {0}
    set {num_disp_values(12,7)} {0}

    set {num_disp_values(13,1)} {0}
    set {num_disp_values(13,2)} {0}
    set {num_disp_values(13,3)} {1}
    set {num_disp_values(13,4)} {1}
    set {num_disp_values(13,5)} {1}
    set {num_disp_values(13,6)} {1}
    set {num_disp_values(13,7)} {1}

    set {num_disp_values(14,1)} {1}
    set {num_disp_values(14,2)} {1}
    set {num_disp_values(14,3)} {1}
    set {num_disp_values(14,4)} {1}
    set {num_disp_values(14,5)} {0}
    set {num_disp_values(14,6)} {0}
    set {num_disp_values(14,7)} {1}

    set {num_disp_values(15,1)} {1}
    set {num_disp_values(15,2)} {1}
    set {num_disp_values(15,3)} {1}
    set {num_disp_values(15,4)} {0}
    set {num_disp_values(15,5)} {0}
    set {num_disp_values(15,6)} {0}
    set {num_disp_values(15,7)} {1}

    set {num_disp_values(16,1)} {0}
    set {num_disp_values(16,2)} {0}
    set {num_disp_values(16,3)} {0}
    set {num_disp_values(16,4)} {0}
    set {num_disp_values(16,5)} {0}
    set {num_disp_values(16,6)} {0}
    set {num_disp_values(16,7)} {0}
}

# Procedure: NumDisplay
# w = width
# h = heigth
# offset = offset between lines
# u = unit of upper values
#
proc NumDisplay {{root ""} {w 14} {h 4} {offset 1} {u ""}} {

    global num_display
    if { "$num_display" != "" } {
	puts "NumDisplay already exists."
	return
    }

    set num_display ${root}.num_display

    InitNumDispValues
    InitNumDispCurrValue

    set x [expr 4*$h]
    set y $h

    canvas $num_display \
	    -highlightthickness 0 \
	    -borderwidth {1} \
	    -height [expr 2*$w+4*$offset+2*$h] \
	    -relief {raised} \
	    -width [ expr $x+6*(2*$offset+$w) + 5*($offset+$h) + 2*$h ]

    for { set j 0 } { $j <=5 } { incr j } {

    if {$j>0} { set x [expr $x+($w+$offset+$h)] }

    set p(1,1,1) [expr $x+$offset]
    set p(1,1,2) $y

    set p(1,2,1) [expr $x+$offset+$w]
    set p(1,2,2) $y

    set p(1,3,1) [expr $x+$offset+$w-$h]
    set p(1,3,2) [expr $y+$h]

    set p(1,4,1) [expr $x+$offset+$h]
    set p(1,4,2) [expr $y+$h]


    set p(2,1,1) $x
    set p(2,1,2) [expr $y+$offset]

    set p(2,2,1) [expr $x+$h]
    set p(2,2,2) [expr $y+$offset+$h]

    set p(2,3,1) [expr $x+$h]
    set p(2,3,2) [expr $y+$offset+$w-$h/2]

    set p(2,4,1) $x
    set p(2,4,2) [expr $y+$offset+$w]


    set p(3,1,1) $x
    set p(3,1,2) [expr $y+$offset+$w+2*$offset]

    set p(3,2,1) [expr $x+$h]
    set p(3,2,2) [expr $y+$offset+$w+2*$offset+$h/2]

    set p(3,3,1) [expr $x+$h]
    set p(3,3,2) [expr $y+$offset+$w+2*$offset+$w-$h]

    set p(3,4,1) $x
    set p(3,4,2) [expr $y+$offset+$w+2*$offset+$w]


    set p(4,1,1) [expr $x+$offset]
    set p(4,1,2) [expr $y+$offset+$w+2*$offset+$w+$offset]

    set p(4,4,1) [expr $x+$offset+$w]
    set p(4,4,2) [expr $y+$offset+$w+2*$offset+$w+$offset]

    set p(4,3,1) [expr $x+$offset+$w-$h]
    set p(4,3,2) [expr $y+$offset+$w+2*$offset+$w+$offset-$h]

    set p(4,2,1) [expr $x+$offset+$h]
    set p(4,2,2) [expr $y+$offset+$w+2*$offset+$w+$offset-$h]


    set p(5,1,1) [expr $x+$offset+$w+$offset]
    set p(5,1,2) [expr $y+$offset+$w+2*$offset+$w]

    set p(5,2,1) [expr $x+$offset+$w+$offset]
    set p(5,2,2) [expr $y+$offset+$w+2*$offset]

    set p(5,3,1) [expr $x+$offset+$w+$offset-$h]
    set p(5,3,2) [expr $y+$offset+$w+2*$offset+$h/2]

    set p(5,4,1) [expr $x+$offset+$w+$offset-$h]
    set p(5,4,2) [expr $y+$offset+$w+2*$offset+$w-$h]


    set p(6,1,1) [expr $x+$offset+$w+$offset]
    set p(6,1,2) [expr $y+$offset+$w]

    set p(6,2,1) [expr $x+$offset+$w+$offset]
    set p(6,2,2) [expr $y+$offset]

    set p(6,3,1) [expr $x+$offset+$w+$offset-$h]
    set p(6,3,2) [expr $y+$offset+$h]

    set p(6,4,1) [expr $x+$offset+$w+$offset-$h]
    set p(6,4,2) [expr $y+$offset+$w-$h/2]
    

    for {set i 1} {$i<=6} {incr i} {
	set disp([expr $j*7+$i]) [$num_display create polygon \
		$p($i,1,1)$u $p($i,1,2)$u \
		$p($i,2,1)$u $p($i,2,2)$u \
		$p($i,3,1)$u $p($i,3,2)$u \
		$p($i,4,1)$u $p($i,4,2)$u]
    }

    set disp([expr $j*7+7]) [ $num_display create polygon \
	    [expr $x+$offset]$u [expr $y+$offset+$w+$offset]$u \
	    [expr $x+$offset+$h]$u [expr $y+$offset+$w+$offset-$h/2]$u \
	    [expr $x+$offset+$w-$h]$u [expr $y+$offset+$w+$offset-$h/2]$u \
	    [expr $x+$offset+$w]$u [expr $y+$offset+$w+$offset]$u \
	    [expr $x+$offset+$w-$h]$u [expr $y+$offset+$w+$offset+$h/2]$u \
	    [expr $x+$offset+$h]$u [expr $y+$offset+$w+$offset+$h/2]$u ]

    if { ($j == 1) || ($j == 3) } {
	set p1($j) "$num_display create oval \
		[expr $x+$offset+$w+$h-$offset] \
		[expr $y+$offset+$w/2-$offset]$u \
		[expr $x+$offset+$w+$offset+$h+$offset] \
		[expr $y+$offset+$w/2+$offset]$u -fill black"

	set p2($j) "$num_display create oval \
		[expr $x+$offset+$w+$h-$offset] \
		[expr $y+$offset+$w+2*$offset+$w/2-$offset]$u \
		[expr $x+$offset+$w+$offset+$h+$offset] \
		[expr $y+$offset+$w+2*$offset+$w/2+$offset]$u -fill black"
	set x [expr $x+$h]
    }

  }
  eval $p1(1)
  eval $p2(1)
  eval $p1(3)
  eval $p2(3)
  set x [expr $x-5*$h-5*($w+$offset+$h)]

  $num_display create polygon \
	  [expr $x+$offset]$u	[expr $y+$offset+$w+$offset-$h/2]$u \
	  [expr $x+$offset+2*$h]$u	[expr $y+$offset+$w+$offset-$h/2]$u \
	  [expr $x+$offset+2*$h]$u	[expr $y+$offset+$w+$offset+$h/2]$u \
	  [expr $x+$offset]$u 	[expr $y+$offset+$w+$offset+$h/2]$u

  SetNumDisplay $num_display 0 0 0 0
  return  $num_display
}


proc SetNumDisplay { num_canvas {sign 0} {disp(1) 0} {disp(2) 0} {disp(3) 0}\
	                                 {disp(4) 0} {disp(5) 0} {disp(6) 0} } {
    global num_disp_values
    global num_disp_curr_value curr_time

     for {set j 1} {$j <= 6} {incr j} {
       if { $disp($j) > 16 } {
	 puts "SetNumDisplay: value $disp($j) out of range!\n"
	 set disp($j) 16
       }
       if { $disp($j) < 0 } {
	 puts "SetNumDisplay: value $disp($j) out of range!\n"
	 set disp($j) 16
       }
       if { $num_disp_curr_value($j,8) != $disp($j) } {
	 for {set i 1} {$i <= 7} {incr i} {
           if { $num_disp_curr_value($j,$i) != $num_disp_values($disp($j),$i) } {
	     if { $num_disp_values($disp($j),$i) == 0 } {
	       $num_canvas itemconfigure [expr ($j-1)*7+$i] -fill ""
             } else {
               $num_canvas itemconfigure [expr ($j-1)*7+$i] -fill black
	     }
	     set num_disp_curr_value($j,$i) $num_disp_values($disp($j),$i)
	  }
          set num_disp_curr_value($j,8) $disp($j)
	}
      }
    }
    if { $num_disp_curr_value(7,1) != $sign } {
	if { $sign < 0 } {
	    $num_canvas itemconfigure 47 -fill black
	} else {
	    $num_canvas itemconfigure 47 -fill ""
	}
        set num_disp_curr_value(7,1) $sign
    }
    set curr_time "$disp(1)$disp(2):$disp(3)$disp(4):$disp(5)$disp(6)"
    if { $sign < 0 } {
	set curr_time "- $curr_time"
    }
}
